#
# 03/13/15 [HET]: I was going to use these on tk_box_num_v2.rbw but decided I do not need them.
#
# This checks a line from a ruby code source file to see if we are ready to start processing the calculations
# part of the Ruby Code. We do not want the Data Flow code.
#
# Return Values:
#
# 0 -> Can not tell yet if we are in Calcs section.
# 1 -> We are in DataFlow.
# 2-> We are entering Calcs Section on next file read.
# 3-> We are in the Calcs section.
#
def check_calcs(str)

	case (str.delete("\s\t").downcase)

		when (/= *(individual|preparer|entity|fiduciary|fcc)\.new/): 1
		when (/(individual|preparer|entity|fiduciary|fcc)\.[a-z]/): 1
		when (/#end(of)?dataflow/): 2
		when (/#dataflow(end|stop)/): 2
		when (/#nodataflow/): 2
		when (/box\d+_\d+=/): 3
		when (/print'box\d+_\d+',box\d+_\d+/): 3
		else 0
	end
end

#
# This reads in the Calcs section [not the Data Flow] from a form if there is one.
#
def read_ruby_code(fname, in_text)

	tmp_array = Array.new
	pre_process = false
	process_calcs = false

	in_text.delete("1.0", "end")

	File.open(fname, "r") do |src_file|

		while (line = src_file.gets)

			case
				when (line =~ /\$\\="\\x03\\n"/): pre_process = true

				when (pre_process)

					#
					# We are in the calculations section [data flow and calcs] of the form, check if we
					# can start processing the calcs.
					#
					case (check_calcs(line))

						when (0): tmp_array.push(line)

						when (1)

							#
							# We either read a profile instantiation "profile = Profile.new" or a profile
							# reference "profile.member_name".
							#
							tmp_array.clear

						when (2)

							#
							# We read an end of data flow comment so we are entering the Calcs section on our
							# next read.
							#
#~ in_text.insert("end", "End of data flow comment - tmp_array:\n#{tmp_array}\n")

							pre_process = false
							process_calcs = true
							tmp_array.clear
#~ in_text.insert("end", "cleared tmp_array:#{tmp_array}")

						when (3)

							#
							# We are in the Calcs section - we either assigned to a box or printed a box, we did
							# not read an end of data flow comment. tmp_array most likely contains Calcs code:
							#
							tmp_array.push(line)
#~ in_text.insert("end", "when (3) pushing line: #{line}\n")
							pre_process = false
							process_calcs = true
					end

				when (process_calcs)

					#
					# We have entered the calculations section of the file, and tmp_array may have some calc stuff in it.
					#
#~ in_text.insert("end", "when (process_calcs) pushing line: #{line}\n")
					tmp_array.push(line)
			end
		end
	end
	#
	# Not sure why, but if I just insert the entire tmp_array we get starting '{' and ending '}' for each line.
	#
	tmp_array.each do |line| in_text.insert("end", line) end
end
